﻿using System.Web;
using System.Web.Compilation;
using System.Web.Routing;
using System.Web.UI;
using SampleRouting.WebForms;
using System.Web.Security;
using System.Security;
using System.Net;

namespace SampleRouting.Routing
{
    public class RecipeRouteHandler : IRouteHandler
    {
        public RecipeRouteHandler(string virtualPath)
        {
            _virtualPath = virtualPath;
        }

        public IHttpHandler GetHttpHandler(RequestContext requestContext)
        {
            if (!UrlAuthorizationModule.CheckUrlAccessForPrincipal(
                _virtualPath, requestContext.HttpContext.User,
                              requestContext.HttpContext.Request.HttpMethod))
            {
                requestContext.HttpContext.Response.StatusCode = (int)HttpStatusCode.Unauthorized;
                requestContext.HttpContext.Response.End();                
            }

            var display = BuildManager.CreateInstanceFromVirtualPath(
                            _virtualPath, typeof(Page)) as IRecipeDisplay;

            display.RecipeName = requestContext.RouteData.Values["name"] as string;
            return display;
        }

        string _virtualPath;
    }
}
